#!/usr/bin/perl
# vim:et:ts=2:sw=2:

#    Lanternor - Used to study lanterns and day signals
#    Copyright (C) 2011  Jonas Eriksson <zqad@acc.umu.se>
# 
#    This program is free software: you can redistribute it and/or modify
#    it under the terms of the GNU Affero General Public License as
#    published by the Free Software Foundation, either version 3 of the
#    License, or (at your option) any later version.
# 
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU Affero General Public License for more details.
# 
#    You should have received a copy of the GNU Affero General Public License
#    along with this program.  If not, see <http://www.gnu.org/licenses/>.

use CGI;

our %patterns;
require("./patterns.pm");

my $q = CGI->new;

my %c;
$c{'black'} = "#000000";
$c{'white'} = "#FFFFFF";

my @pnames = ();
foreach my $hrl (['t', \%toppljus], ['c', \%combos], ['d', \%dager]) {
        @pnames = (@pnames, keys(%{$hrl->[1]})) if ($q->param($hrl->[0]));
}

my $p_t = $q->param('t');
my $p_d = $q->param('d');
my $p_c = $q->param('c');

if ($ENV{QUERY_STRING} eq '') {
        $p_t = 1;
        $p_d = 1;
        $p_c = 1;
        @pnames = (keys(%patterns));
}

my $name = $pnames[int(rand($#pnames + 1))];
my $answer = $patterns{$name}->{'answer'};
my $rand = int(rand(100000000));

my $bg  = $c{'black'};
my $bg_inv = $c{'white'};
if ($patterns{$name}->{'background'} eq 'white') {
  $bg = $c{'white'};
  $bg_inv = $c{'black'};
}

my $c_t = '';
my $c_d = '';
my $c_c = '';
$c_t = 'checked' if ($p_t);
$c_d = 'checked' if ($p_d);
$c_c = 'checked' if ($p_c);

print <<_EOF_
Content-Type: text/html; charset=utf-8

<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01//EN" "http://www.w3.org/TR/html4/strict.dtd">
<html>
  <head>
    <title>Lanternor</title>
    <style type="text/css">
      <!--
      td.x { color: $bg_inv; background-color: $bg_inv; height: 4em }
      td.x:hover { color: $bg }
      body { color: $bg_inv; background-color: $bg; font-family: sans-serif }
      img { border: none }
      //-->
    </style>
  </head>
  <body>
    <table border="0">
      <tr valign="middle">
        <td align="center">
          <a href="?r=$rand&amp;t=$p_t&amp;d=$p_d&amp;c=$p_c">
            <img src="img.cgi?$name" alt="Lanterna">
          </a>
        </td>
      </tr>
      <tr valign="middle">
        <td align="center">
          &nbsp;
        </td>
      </tr>
      <tr valign="middle">
        <td align="center" class="x" style="width: 70%">
          $answer
        </td>
      </tr>
      <tr valign="middle">
        <td style="width: 70%">
          <form method="get" action="">
            <p>
              <input type="hidden" name="r" value="$rand">
              <input type="checkbox" name="t" value="1" id="t" $c_t> <label for="t">Toppljus</label><br>
              <input type="checkbox" name="c" value="1" id="c" $c_c> <label for="c">Lanternekombinationer</label><br>
              <input type="checkbox" name="d" value="1" id="d" $c_d> <label for="d">Dagersignaler</label><br>
              <input type="submit" value="OK">
            </p>
          </form>
        </td>
      </tr>
      <tr>
        <td align="right">
          <p>
            <a href="http://validator.w3.org/check?uri=referer"><img src="http://www.w3.org/Icons/valid-html401" alt="Valid HTML 4.01 Strict" height="31" width="88"></a>
            <a href="http://www.gnu.org/licenses/agpl.html">
              <img src="agpl.png" alt="AGPL v3 logo">
            </a>
          </p>
          <p> 
            <a href="download.cgi">Download source</a>
          </p>
        </td>
      </tr>
    </table>
  </body>
</html>
_EOF_
